//+------------------------------------------------------------------+
//|                                                      Example.mq5 |
//|                                        Copyright 2010, KTS Group |
//|                                               http://www.koss.su |
//+------------------------------------------------------------------+
#property copyright "2010, KTS Group"
#property link      "http://www.koss.su"
#property version   "1.00"

#define     COUNT_PERIODS                                        2        //  
#define     COUNT_SYMBOLS                                        2        //  

#include <Trade\SymbolInfo.mqh>

input int TimerDelay=1;                 //  (.)

                                        // ,       

ENUM_TIMEFRAMES TFrames[COUNT_PERIODS]={PERIOD_H6,PERIOD_H1};         //  (      , ..     COUNT_PERIODS-1)
string Symbols[COUNT_SYMBOLS]={"EURUSD","GBPUSD"};                    //  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CExampleEA
  {
   //---       
protected:

   datetime          Tics[];
   bool              isNewTic();
   void              TicsMonitoring();

   //---       

   datetime          NewBars[][COUNT_PERIODS];
   uchar             isNewBar(int TFPosition);
   uchar             GetNewBars();
   uchar             BarsMonitoring();
   string            Name;
   uint              SymbPos;
   uint              TFPos;
   void              ArraysInitializing(void);

public:
                     CExampleEA();
                    ~CExampleEA() { Deinit(); }
   datetime          Times[1];
   datetime          ZeroBarTime;
   datetime          FirstBarTime;
   bool              isComplete;
   bool              Init();
   void              Deinit();

  };

CExampleEA              EA;
CSymbolInfo           CurrentSymbol;
//+------------------------------------------------------------------+
//|                                                       |
//+------------------------------------------------------------------+

CExampleEA::CExampleEA(void)
  {

  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+

bool CExampleEA::Init(void)
  {
   bool initializing=true;
    //     ,    .. 
   return(initializing);
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+

void CExampleEA::Deinit(void)
  {
   Print("Deinitialization complete!");
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+

void CExampleEA::ArraysInitializing(void)
  {
   ArrayResize(Tics,COUNT_SYMBOLS);
   ArrayInitialize(Tics,0);
   ArrayResize(NewBars,COUNT_SYMBOLS);
   ArrayInitialize(NewBars,0);
   ZeroBarTime=0;
   FirstBarTime=0;
   isComplete=false;
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+

uchar CExampleEA::isNewBar(int TFPosition)
  {
//---
   ENUM_TIMEFRAMES TF=TFrames[TFPosition];
   datetime ZeroTime=0,
   NextBarTime=0,
   CurrentBarTime=0,
   TickTime=0;
   int TimeShift=PeriodSeconds(TF);
   string Comm;
//---

   TickTime       =CurrentSymbol.Time();
   CurrentBarTime =NewBars[SymbPos][TFPosition];
   if(CurrentBarTime<TickTime)
     {
      ZeroTime=iTime(Name,TF,0);
      if(ZeroTime!=0 && CurrentBarTime<=ZeroTime)
        {
         NextBarTime=ZeroTime+TimeShift;
         if(TFPosition==COUNT_PERIODS-1) ZeroBarTime=NextBarTime;
         NewBars[SymbPos][TFPosition]=NextBarTime;
         StringConcatenate(Comm,"New bar on ",Name,TF(TF)," Time: ",TimeToString(ZeroTime,TIME_DATE|TIME_MINUTES));
         Print(Comm);
         return(1);
        }
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|        TF.  |
//|             |
//+------------------------------------------------------------------+

uchar CExampleEA::GetNewBars()
  {
   int i;
   uchar  BarsCounted=0;
   if(isNewBar(COUNT_PERIODS-1)!=0) //       
     {
      BarsCounted++;
      TFPos=COUNT_PERIODS-1;
      if(COUNT_PERIODS>1) //     
        {
         for(i=COUNT_PERIODS-2;i>=0;i--) //    
           {
            if(isNewBar(i)!=0)
              {
               BarsCounted++;
               TFPos=i;
              }
           }
        }
      return(BarsCounted);
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
uchar CExampleEA::BarsMonitoring()
  {
   uchar BarsCounted=GetNewBars();
   uchar isNew=0;
   if(BarsCounted!=0)
     {
      for(int i=0;i<=COUNT_SYMBOLS-1;i++)
        {
         if(NewBars[i][COUNT_PERIODS-1]==ZeroBarTime) isNew++;
        }
      if(isNew==COUNT_SYMBOLS) isComplete=true;   //  ,       / 
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|       |
//+------------------------------------------------------------------+

bool CExampleEA::isNewTic()
  {
   datetime CurrTime;
   bool result=CurrentSymbol.RefreshRates();
   if(result)
     {
      CurrTime=CurrentSymbol.Time();
      if(Tics[SymbPos]!=CurrTime)
        {
         Tics[SymbPos]=CurrTime;
        }
      else result=false;
     }
   else Print("SymbolInfoTick() failed, error =",DoubleToString(GetLastError(),0));

   return(result);
  }
  
//+------------------------------------------------------------------+
//|  Time                               |
//+------------------------------------------------------------------+

datetime iTime(string symbol,ENUM_TIMEFRAMES timeframe,int index)
  {
   datetime time[1];
   int copied=0;
   
      while(!SeriesInfoInteger(symbol,timeframe,SERIES_SYNCRONIZED))
        {
         Sleep(5);
         CopyTime(symbol,timeframe,0,1,time);
        }
    
   if(CurrentSymbol.IsSynchronized())
     {
      copied=CopyTime(symbol,timeframe,0,1,time);
      if(copied>0 && index<copied) return(time[0]);
     }
   return(time[0]);
  }  
//+------------------------------------------------------------------+
//|                    |
//+------------------------------------------------------------------+

void CExampleEA::TicsMonitoring()
  {
   uint i,j=0;
   for(i=0;i<=COUNT_SYMBOLS-1;i++)
     {
      SymbPos=i;
      CurrentSymbol.Name(Symbols[i]);
      if(CurrentSymbol.Select())
        {
         Name=CurrentSymbol.Name();
         if(isNewTic()) //    
           {
            if(Tics[i]>=FirstBarTime) //      TF
              {
               BarsMonitoring();                      //        TF
              }
            else
              {
               //  -     
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+

int OnInit()
  {
   if(!EA.Init())
     {
      EA.Deinit();
      return(-1);
     }
   EA.ArraysInitializing();

//  ,        
   if(!MQL5InfoInteger(MQL5_TESTING))
     {
      int  attempts=0;
      int  g_limit_attempts=10;
      bool g_timer=false;
      while(attempts++<g_limit_attempts)
        {
         if(ChartGetInteger(0,CHART_VISIBLE_BARS)>0)
           {
            g_timer=true;
            break;
           }
         Sleep(10);
        }
      if(g_timer) EventSetTimer(TimerDelay);
     }
   EventSetTimer(TimerDelay);
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   EventKillTimer();
  }
//+------------------------------------------------------------------+
//| Expert timer function                                            |
//+------------------------------------------------------------------+
void OnTimer()
  {
   EA.TicsMonitoring();                                                          //      
   if(EA.isComplete)                                                             //        ,   
     {
      EA.FirstBarTime=EA.ZeroBarTime;                                            //        
      EA.ZeroBarTime=0;
      Print("New bars monitoring is complete!");
      EA.isComplete=false;                                                       //  
     }
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+

string TF(ENUM_TIMEFRAMES period)
  {
   if(period==PERIOD_CURRENT) period=Period();
//---
   switch(period)
     {
      case PERIOD_M1:  return(": M1");
      case PERIOD_M2:  return(": M2");
      case PERIOD_M3:  return(": M3");
      case PERIOD_M4:  return(": M4");
      case PERIOD_M5:  return(": M5");
      case PERIOD_M6:  return(": M6");
      case PERIOD_M10: return(": M10");
      case PERIOD_M12: return(": M12");
      case PERIOD_M15: return(": M15");
      case PERIOD_M20: return(": M20");
      case PERIOD_M30: return(": M30");
      case PERIOD_H1:  return(": H1");
      case PERIOD_H2:  return(": H2");
      case PERIOD_H3:  return(": H3");
      case PERIOD_H4:  return(": H4");
      case PERIOD_H6:  return(": H6");
      case PERIOD_H8:  return(": H8");
      case PERIOD_H12: return(": H12");
      case PERIOD_D1:  return(": Daily");
      case PERIOD_W1:  return(": Weekly");
      case PERIOD_MN1: return(": Monthly");
     }
//---
   return("unknown period");
  }
 
